#ifndef ALGORITHM_H
#define ALGORITHM_H 1

// This header file defining the interface of the simple demonstration
// function "algorithm".  This header file is included by both
// algorithm.cpp, which defines the body of the function, and
// test_adept.cpp, which calls algorithm. The function has two
// overloaded forms, the "original" version taking double-precision
// arguments and returning a double-precision answer, and the
// automatic differentiation version taking adouble arguments and
// returning an adouble answer. The two versions are compiled from the
// same source file algorithm.cpp by compiling it twice with and
// without the compiler option -DAUTOMATIC_DIFFERENTIATION.

// Include the header file that includes adept.h only if the compler
// has been called with -DAUTOMATIC_DIFFERENTIATION.
#include "adept_optional.h"

// Declare the original version of the function
double algorithm(const double x[2]);

#ifdef AUTOMATIC_DIFFERENTIATION
// Declare the automatic-differentiation version of the function
adept::adouble algorithm(const adept::adouble x[2]);
#endif

#endif
